package com.usky.dxtop.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import com.usky.dxtop.mapper.CallApiLogMapper;
import com.usky.dxtop.model.CallApiLog;
import com.usky.dxtop.service.CallApiLogService;
import com.usky.dxtop.service.api.TopApi;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * <p>
 * 调用api记录表 服务实现类
 * </p>
 *
 * @author yq
 * @since 2021-08-26
 */
@Service
public class CallApiLogServiceImpl extends ServiceImpl<CallApiLogMapper, CallApiLog> implements CallApiLogService {


    @Transactional(rollbackFor = Exception.class)
    @Override
    public CallApiLog add(String orderNumber, String apiName, String url, String param,String result) {
        CallApiLog callApiLog = new CallApiLog();
        callApiLog.setApiUrl(url);
        callApiLog.setApiParam(param);
        callApiLog.setOrderNumber(orderNumber);
        callApiLog.setName(apiName);
        callApiLog.setApiResultData(result);
        this.save(callApiLog);
        return callApiLog;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean update(CallApiLog callApiLog) {
        return this.updateById(callApiLog);
    }

    @Override
    public CallApiLog one(String orderNumber, String apiName) {
        LambdaQueryWrapper<CallApiLog> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper.eq(CallApiLog::getOrderNumber,orderNumber)
                .eq(CallApiLog::getName,apiName);
        return this.getOne(queryWrapper);
    }
}
